<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- data table -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap4.min.js"></script>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
    */
    var gStudents = [
      {
        id: 2, // tự tăng
        studentCode: "1356783",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        studyYear: 2015
      },
      {
        id: 3, // tự tăng
        studentCode: "1356784",
        firstname: "Nguyen Van",
        lastname: "Thanh",
        age: 18,
        email: "thanh@gmail.com",
        studyYear: 2015
      },
      {
        id: 4, // tự tăng
        studentCode: "1356785",
        firstname: "Le Van",
        lastname: "Tuan",
        age: 18,
        email: "tuan@gmail.com",
        studyYear: 2015
      },
      {
        id: 5, // tự tăng
        studentCode: "1356786",
        firstname: "Pham Thi",
        lastname: "Quynh",
        age: 18,
        email: "quynh@gmail.com",
        studyYear: 2015
      },
      {
        id: 6, // tự tăng
        studentCode: "1356787",
        firstname: "Le Duc",
        lastname: "Huy",
        age: 18,
        email: "huy@gmail.com",
        studyYear: 2015
      },
      {
        id: 7, // tự tăng
        studentCode: "1356786",
        firstname: "Dinh Tran Gia",
        lastname: "Bao",
        age: 18,
        email: "bao@gmail.com",
        studyYear: 2015
      },
    ];

    var gSubjects = [
      {
        id: 5, // tự tăng
        subjectCode: "MATH101",
        subjectName: "Toán cao cấp 1"
      },
      // điền thêm 04 môn học nữa
      {
        id: 6, // tự tăng
        subjectCode: "ENG102",
        subjectName: "Tiếng anh căn bản 1"
      },
      {
        id: 7, // tự tăng
        subjectCode: "PHYSICS105",
        subjectName: "Vật lý đại cương 1"
      },
      {
        id: 8, // tự tăng
        subjectCode: "CHEMISTRY106",
        subjectName: "Hóa học đại cương 1"
      },
      {
        id: 9, // tự tăng
        subjectCode: "CHINESE109",
        subjectName: "Tiếng Trung căn bản 1"
      },
    ];

    var gGrades = [
      {
        id: 2, // tự tăng
        studentId: 2,
        subjectId: 5,
        grade: 8,
        examDate: "13/04/2021"
      },
      // điền thêm 9 kết quả thi nữa
      {
        id: 2, // tự tăng
        studentId: 4,
        subjectId: 7,
        grade: 6,
        examDate: "13/04/2021"
      },
      {
        id: 3, // tự tăng
        studentId: 4,
        subjectId: 8,
        grade: 9,
        examDate: "13/04/2021"
      },
      {
        id: 4, // tự tăng
        studentId: 7,
        subjectId: 8,
        grade: 5,
        examDate: "13/04/2021"
      },
      {
        id: 5, // tự tăng
        studentId: 6,
        subjectId: 8,
        grade: 6,
        examDate: "13/04/2021"
      },
      {
        id: 6, // tự tăng
        studentId: 4,
        subjectId: 7,
        grade: 7.6,
        examDate: "13/04/2021"
      },
      {
        id: 7, // tự tăng
        studentId: 2,
        subjectId: 7,
        grade: 6,
        examDate: "13/04/2021"
      },
      {
        id: 8, // tự tăng
        studentId: 3,
        subjectId: 6,
        grade: 7,
        examDate: "13/04/2021"
      },
      {
        id: 9, // tự tăng
        studentId: 6,
        subjectId: 7,
        grade: 10,
        examDate: "13/04/2021"
      },
    ];
    var gSTT = 1;
    var gStudentTable;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading()
      //hàm thực thi ấn nút lọc dữ liệu
      $("#btn-filter").on("click", function () {
        var vFilteredStudent = gGrades.filter(filterStudentData);
        console.log(vFilteredStudent)
        loadDataStudentFilteredToTable(vFilteredStudent)
      })
    });


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      gStudentTable = $("#student-table").DataTable({
        data: gGrades,
        columns: [
          { data: "id" },
          { data: "studentId" },
          { data: "subjectId" },
          { data: "grade" },
          { data: "examDate" }
        ],
        columnDefs: [
          {
            target: 0,
            render: function renderSTT() {
              return gSTT++
            }
          },
          {
            target: 1,
            render: renderStudentIdToStudentName
          },
          {
            target: 2,
            render: renderSubjectIdToSubjectName
          },
        ]

      });
      loadDataToStudentSelect();
      loadDataToSubjectSelect()
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm render student id to studentName
    function renderStudentIdToStudentName(paramStudentId) {
      for (var bI = 0; bI < gStudents.length; bI++) {
        if (paramStudentId == gStudents[bI].id) {
          var bStudentName = gStudents[bI].firstname + " " + gStudents[bI].lastname
          console.log(bStudentName)
          return bStudentName
        }
      }
    };
    //hàm render subject id to subject name
    function renderSubjectIdToSubjectName(paramSubjectId) {
      for (var bI = 0; bI < gSubjects.length; bI++) {
        if (paramSubjectId == gSubjects[bI].id) {
          var bSubjectName = gSubjects[bI].subjectName
          console.log(bSubjectName)
          return bSubjectName
        }
      }
    }
    //hàm load data to Student select:
    function loadDataToStudentSelect() {
      for (var bI = 0; bI < gStudents.length; bI++) {
        $("#select-student").append(`<option value="${gStudents[bI].id}">${gStudents[bI].firstname + " " + gStudents[bI].lastname}</option>`)
      }
    }

    //hàm load data to subject select:
    function loadDataToSubjectSelect() {
      for (var bI = 0; bI < gSubjects.length; bI++) {
        $("#select-subject").append(`<option value="${gSubjects[bI].id}">${gSubjects[bI].subjectName}</option>`)
      }
    };
    //hàm lọc student:
    function filterStudentData(paramStudentData) {
      var vStudentId = $("#select-student").val();
      var vSubjectId = $("#select-subject").val();
      //lọc khi select student và select subject đều được chọn
      if ($("#select-student").val() != 0 && $("#select-subject").val() != 0) {
        if (paramStudentData.studentId == vStudentId && paramStudentData.subjectId == vSubjectId) {
          return paramStudentData.studentId == vStudentId && paramStudentData.subjectId == vSubjectId
        }
      };
      //lọc khi select student hoặc select subject được chọn
      if ($("#select-student").val() != 0 || $("#select-subject").val() != 0) {
        if (paramStudentData.studentId == vStudentId || paramStudentData.subjectId == vSubjectId) {
          return paramStudentData.studentId == vStudentId || paramStudentData.subjectId == vSubjectId
        }
      }
    };
    //hàm load data student filtered to table:
    function loadDataStudentFilteredToTable(paramStudentData) {
      if(paramStudentData.length != 0){
      gStudentTable.clear();
      gStudentTable.rows.add(paramStudentData);
      gStudentTable.draw()
    }else{
      alert ("Không tìm thấy sinh viên!");
      window.location.reload()
    }
    }
  </script>
</head>

<body>
  <div class="container">
    <div class="form-group">
      <!-- <pre>
        - Định nghĩa 03 đối tượng students (sinh viên), subjects (môn học) và grades (bảng điểm)
        - Điền dữ liệu mẫu cho 03 đối tượng trên. 
            + Student điền 5 sinh viên
            + Subject điền 5 môn học
            + Grades: điền 10 kết quả học tập cho các sinh viên và môn học ở trên
        - Thực hiện load dữ liệu bảng điểm (grades)
        - Thêm bộ lọc theo 2 ô select: Student và Subject
      </pre> -->
      <div class="text-center">
        <h3>200 - LỊCH SỬ HỌC TẬP</h3>
      </div>
      <div class="div-filter jumbotron">
        <div class="row">
          <div class="col-lg-5 col-sm-6 d-flex h-100 justify-content-center">
            <label class="mr-4" for="select-student" style="font-weight: 500;">Student</label>
            <select name="" id="select-student" class="bg-info text-white w-50">
              <option value="0">Chọn tên sinh viên</option>
            </select>
          </div>
          <div class="col-lg-5 col-sm-6 d-flex h-100 justify-content-center">
            <label class="mr-4" for="select-subject" style="font-weight: 500;">Subject</label>
            <select name="" id="select-subject" class="bg-info text-white w-50">
              <option value="0">Chọn môn học</option>
            </select>
          </div>
          <div class="col-lg-2 col-md-12 text-center">
            <button id="btn-filter" class="btn btn-success">Lọc dữ liệu</button>
          </div>
        </div>
      </div>
      <table id="student-table" class="table table-bordered table-striped table-hover table-primary table-lg">
        <thead class="text-light" style="font-weight: 500; ">
          <tr>
            <td>STT</td>
            <td>Student</td>
            <td>Môn học</td>
            <td>Điểm</td>
            <td>Ngày thi</td>
          </tr>
        </thead>
      </table>
    </div>
  </div>
</body>

</html>